#pragma once

#include <chrono>

namespace jlog {
    class Timestamp {
    public:
        Timestamp();
    public:
        [[nodiscard]] std::chrono::year Year() const {return y;};
        [[nodiscard]] std::chrono::month Month() const {return m;};
        [[nodiscard]] std::chrono::day Day() const {return d;}
        [[nodiscard]] std::chrono::duration<long, std::ratio<3600>> Hour() const {return h;};
        [[nodiscard]] std::chrono::duration<long, std::ratio<60>> Minute() const {return M;};
        [[nodiscard]] std::chrono::duration<long> Second() const {return s;};
        [[nodiscard]] std::chrono::duration<long, std::ratio<1, 1000>> Millisecond() const {return ms;};
    private:
        std::chrono::year y;
        std::chrono::month m;
        std::chrono::day d;
        std::chrono::duration<long, std::ratio<3600>> h;
        std::chrono::duration<long, std::ratio<60>> M;
        std::chrono::duration<long> s;
        std::chrono::duration<long, std::ratio<1, 1000>> ms;
    };
}